import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ThinkAuthGroup, ThinkAuthGroupParam } from './model';
import { THINK_API_URL } from '@/config/setting';

/**
 * 分页查询
 */
export async function pageThinkAuthGroup(params: ThinkAuthGroupParam) {
  const res = await request.get<ApiResult<PageResult<ThinkAuthGroup>>>(
    THINK_API_URL + '/think/think-auth-group/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询列表
 */
export async function listThinkAuthGroup(params?: ThinkAuthGroupParam) {
  const res = await request.get<ApiResult<ThinkAuthGroup[]>>(
    THINK_API_URL + '/think/think-auth-group',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加
 */
export async function addThinkAuthGroup(data: ThinkAuthGroup) {
  const res = await request.post<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-auth-group',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改
 */
export async function updateThinkAuthGroup(data: ThinkAuthGroup) {
  const res = await request.put<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-auth-group',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除
 */
export async function removeThinkAuthGroup(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-auth-group/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除
 */
export async function removeBatchThinkAuthGroup(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-auth-group/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询
 */
export async function getThinkAuthGroup(id: number) {
  const res = await request.get<ApiResult<ThinkAuthGroup>>(
    THINK_API_URL + '/think/think-auth-group/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
